%{!?python_sitelib: %define python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define appname virtinst

Summary: Python modules and utilities for installing virtual machines
Name: python-%{appname}
Version: 0.400.3
Release: 12%{?dist}
Source0: http://virt-manager.org/download/sources/%{appname}/%{appname}-%{version}.tar.gz

# Fix virt-image invocation with create-on-the-fly disk images
Patch1: %{appname}-%{version}-fix-virtimage-scratch.patch
# Add disk_exists util method, used by prompting patch
Patch2: %{appname}-%{version}-disk-exists.patch
# Revive virt-* prompting. Turned off by default, need --prompt flag to invoke
Patch3: %{appname}-%{version}-revive-prompting.patch
# Fix some hostdev bugs in the release, set managed=no for xen
Patch4: %{appname}-%{version}-hostdev-fixes.patch
# Workaround for satellite URL roots not resolving, which we use for a
# tree sanity check
Patch5: %{appname}-%{version}-satellite-fix.patch
# Fix virt-install --disk device=floppy (bz 503053)
Patch6: %{appname}-%{version}-fix-floppy.patch
# Fix virt-install --disk pool= and vol= (bz 503073)
Patch7: %{appname}-%{version}-fix-pool-vol.patch
#- Make sure detected OS is in our dictionary (bz 503092)
Patch8: %{appname}-%{version}-validate-detected-os.patch
# More PCI device assignment fixes (bz 499576)
Patch9: %{appname}-%{version}-fix-pci-assign.patch
# RHEL ONLY: Allow old (erroneous) xen HVM --location behavior (bz 503473)
Patch10: %{appname}-%{version}-fix-xenfv-location.patch
# Use libvirt connection auto-detection, rather than our own hack (bz 505450)
Patch11: %{appname}-%{version}-libvirt-default-conn.patch
# Fix --cdrom URL installs (bz 506714)
Patch12: %{appname}-%{version}-fix-cdrom-url.patch
# Add cli test suite from upstream (useful for verifying patchs)
Patch13: %{appname}-%{version}-add-cli-test.patch
# Use ac97 sound model for qemu (bz 508747)
Patch14: %{appname}-%{version}-use-ac97.patch
# Don't throw errors with unicode using locales (bz 508784)
Patch15: %{appname}-%{version}-unicode-fix.patch
# virt-convert: allow converting to qcow2 (bz 506927)
Patch16: %{appname}-%{version}-virtconv-qcow2.patch
# Don't fail if a storage volume was manually deleted (bz 511925)
Patch17: %{appname}-%{version}-info-vol-refresh.patch
# virt-install: Fix --prompt and --disk interaction (bz 516129)
Patch18: %{appname}-%{version}-fix-disk-prompt.patch
# Fix virt-install --wait <= 0 (bz 512931, bz 517081)
Patch19: %{appname}-%{version}-fix-wait.patch
# Fix badly formatted error message (bz 523767)
Patch20: %{appname}-%{version}-poor-error-message.patch
# Better post install error handling and reporting (bz 545837, bz 498237)
Patch21: %{appname}-%{version}-catch-postinst-errs.patch
# virt-image: Hide unimplemented --prompt option (bz 503721)
Patch22: %{appname}-%{version}-hide-virtimage-prompt.patch
# Default to cache=none for new qemu guests (bz 512072)
Patch23: %{appname}-%{version}-default-cache-none.patch
# Add RHEL5.4 os dictionary entry (bz 547380)
Patch24: %{appname}-%{version}-osdict-rhel54.patch
# Use O_DSYNC when creating nonsparse files (bz 558855)
Patch25: %{appname}-%{version}-nonsparse-DSYNC.patch
# Fix non-sparse storage volume creation (bz 569339)
Patch26: %{appname}-%{version}-enable-nonsparse-vol.patch
# Don't through prompt error if cloning guest to block device (bz 616658)
Patch27: %{appname}-%{version}-clone-overwrite-block.patch
# virt-install: Error if --extra-args specified without --location (bz 593410)
Patch28: %{appname}-%{version}-check-extraargs.patch
# Fix QEMU MAC prefix documentation (bz 620838)
Patch29: %{appname}-%{version}-qemu-mac.patch
# virt-install: Fix generating xen MAC addresses (bz 679949)
Patch30: %{appname}-fix-xen-mac.patch
# virt-install: Add --disk,format= option (bz 644271)
Patch31: %{appname}-qemu-disk-driver.patch
# Mark disk bootable during cdrom installs to help win virtio drivers (bz 568294)
Patch32: %{appname}-facilitate-win-virtio.patch

License: GPLv2+
Group: Development/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch
Url: http://virt-manager.org/
Provides: xeninst
Provides: python-xeninst = %{version}
Provides: virtinst
Provides: virt-install
Provides: virt-clone
Provides: virt-image
Provides: virt-pack
Provides: virt-convert
Requires: libvirt-python >= 0.2.1
Requires: urlgrabber
Requires: libxml2-python
Requires: python-urlgrabber
BuildRequires: gettext
BuildRequires: python
Obsoletes: python-xeninst < %{version}

%description
virtinst is a module that helps build and install libvirt based virtual
machines. Currently supports KVM, QEmu and Xen virtual machines. Package
includes several command line utilities, including virt-install (build
and install new VMs) and virt-clone (clone an existing virtual machine).

%prep
%setup -q -n %{appname}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1

%build
python setup.py build

%install
rm -rf $RPM_BUILD_ROOT
python setup.py install -O1 --root=$RPM_BUILD_ROOT
# Back compat in case people hardcoded old /usr/sbin/virt-install location
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
ln -s ../bin/virt-install $RPM_BUILD_ROOT/%{_sbindir}/virt-install

%find_lang %{appname} || echo 0

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{appname}.lang
%defattr(-,root,root)
%doc README COPYING AUTHORS NEWS ChangeLog doc/image.rng doc/example1.xml
%dir %{python_sitelib}/%{appname}
%dir %{python_sitelib}/virtconv
%{python_sitelib}/%{appname}/*
%{python_sitelib}/virtconv/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_sbindir}/virt-install
%{_bindir}/virt-install
%{_bindir}/virt-clone
%{_bindir}/virt-image
%{_bindir}/virt-convert

%changelog
* Thu Dec 15 2011 Eddy Nigg <eddy_nigg@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Fri Apr 29 2011 Cole Robinson <crobinso@redhat.com> - 0.400.3-12.el5
- virt-install: Fix generating xen MAC addresses (bz 679949)
- virt-install: Add --disk,format= option (bz 644271)
- Mark disk bootable during cdrom installs to help win virtio drivers
  (bz 568294)

* Tue Sep 14 2010 Cole Robinson <crobinso@redhat.com> - 0.400.3-11
- virt-install: Error if --extra-args specified without --location (bz 593410)
- Fix QEMU MAC prefix documentation (bz 620838)
- Prevent unicode patch from altering .orig file (bz 579976)

* Fri Aug 27 2010 Cole Robinson <crobinso@redhat.com> - 0.400.3-10
- Don't through prompt error if cloning guest to block device (bz 616658)

* Tue Mar 02 2010 Cole Robinson <crobinso@redhat.com> - 0.400.3-9.el5
- Fix non-sparse storage volume creation (bz 569339)

* Tue Feb 09 2010 Cole Robinson <crobinso@redhat.com> - 0.400.3-8.el5
- Use O_DSYNC when creating nonsparse files (bz 558855)

* Tue Dec 15 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-7.el5
- Add RHEL5.4 os dictionary entry (bz 547380)

* Sun Dec 13 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-6.el5
- virt-convert: allow converting to qcow2 (bz 506927)
- Don't fail if a storage volume was manually deleted (bz 511925)
- virt-install: Fix --prompt and --disk interaction (bz 516129)
- Fix virt-install --wait <= 0 (bz 512931, bz 517081)
- Fix badly formatted error message (bz 523767)
- Better post install error handling and reporting (bz 545837, bz 498237)
- virt-image: Hide unimplemented --prompt option (bz 503721)
- Default to cache=none for new qemu guests (bz 512072)

* Tue Jul  7 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-5.el5
- Use ac97 as only sound model for qemu driver (bz 508747)
- Don't throw errors with unicode using locales (bz 508784)

* Sun Jun 21 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-4.el5
- Fix --cdrom URL installs (bz 506714)

* Sun Jun 14 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-3.el5
- Fix URI autodetection (bz 505450)

* Mon Jun  8 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-2.el5
- Fix virt-install --disk device=floppy (bz 503053)
- Fix virt-install --disk vol= and pool= (bz 503073)
- Make sure detected OS is in our dictionary (bz 503092)
- Fix PCI device assignment detach/reset calls (bz 499576)
- Restore old --location behavior for xen HVM (bz 503473)

* Mon Mar 23 2009 Cole Robinson <crobinso@redhat.com> - 0.400.3-1.el5
- Rebase to version 0.400.3 (bz 489375)

* Mon Nov 11 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-12.el5
- Don't add spurious forward slashes in urls (bz 470891)
- Fix FTP treeinfo false positives (bz 470888)
- Revert fix for bz 446950, push to 5.4 (bz 470176)

* Wed Oct 8 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-11.el5
- Allow --extra-args for hvm guests using kernel boot (bz 463951)

* Thu Sep 18 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-10.el5
- Add --wait option to virt-install (bz 306871)
- Fix fetching newer suse kernels (bz 449129)
- Parse treeinfo files for newer fedora trees (bz 460585)
- Keep windows media inserted for second install stage (bz 447791)
- Build fix so we don't fail if imports aren't present.

* Sun Sep 14 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-9.el5
- Add win2008 and f9 as distro options (rhbz #442702)
- Exit with proper error code if we receive wrong cli value (rhbz #444986)
- Remove virt-viewer from Requires, so we don't require X (rhbz #448505)
- Catch errors during domain lookup (rhbz #288391)
- Correctly print help messages with unicode characters (rhbz #446950)
- Allow installing from Scientific Linux trees (rhbz #448634)
- Add --cpuset=auto command for numa allocation (rhbz #438554)

* Tue Apr  1 2008 Daniel P. Berrange <berrange@redhat.com> - 0.300.2-8.el5
- Hide libvirt errors from console (rhbz #439850)

* Tue Mar 18 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-7.el5
- Fix file check to allow installing rawhide/f9 guests (rhbz #437595)

* Fri Mar 7 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-6.el5
- Add --force option to cli utils to not prompt for input.
- Remove check for file existence in cli utils, breaks scripts.
- (rhbz #434786)

* Mon Feb 25 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-5.el5
- Bring satellite distro patch up to speed with current internal API
- (rhbz #433831)

* Tue Feb 19 2008 Daniel P. Berrange <berrange@redhat.com> - 0.300.2-4.el5
- Re-add --noreboot option accidentally lost (rhbz #433491)

* Tue Feb 19 2008 Daniel P. Berrange <berrange@redhat.com> - 0.300.2-3.el5
- Fix ACPI default value to be enabled (rhbz #432845)

* Mon Feb 4 2008 Cole Robinson <crobinso@redhat.com> - 0.300.2-2.el5
- Fix virt-clone disk validation from breaking all use of the tool.
- (rhbz #431436)

* Tue Jan 15 2008 Daniel P. Berrange <berrange@redhat.com> - 0.300.2-1.el5
- Update to 0.300.2 release (rhbz #428161)

* Fri Jan 4 2008 Cole Robinson <crobinso@redhat.com> - 0.103.0-6.el5
- Validation and error message fixes across the board.
- (rhbz #201948 #249424 #372001 #221542)

* Fri Dec 7 2007 Cole Robinson <crobinso@redhat.com> - 0.103.0-5.el5
- Fix installing from a tree provided by a satellite server (bz #367051)

* Wed Nov 28 2007 Daniel P. Berrange <berrange@redhat.com> - 0.103.0-4.el5
- Fix install of F8 distros (rhbz #384791)

* Fri Aug 3 2007 Hugh O. Brock <hbrock@redhat.com> - 0.103.0-3.el5
- Patch to have virtinst set up the guest without auto-reboot. Useful 
- for testing. Thanks to Jeff Burke (bz #249708)

* Thu Jul 19 2007 Hugh O. Brock <hbrock@redhat.com> - 0.103.0-2.el5
- Patch so that apic/acpi settings actually work (bz #248487)

* Tue May  1 2007 Daniel P. Berrange <berrange@redhat.com> - 0.103.0-1.el5
- Update to 0.103.0 upstream release (bz #243465)

* Wed Jan 24 2007 Daniel Berrange <berrange@redhat.com> - 0.99.0-2.el5
- use dd with o_direct to create non-sparse files (bz #223491)

* Fri Dec 15 2006 Jeremy Katz <katzj@redhat.com> - 0.99.0-1.el5
- support upstream pvfb config syntax (danpb, #219195)
- don't traceback on invalid memory param (gcosta, #219270)
- let the console come back quicker to help with HVM installs (#212024)

* Thu Nov 30 2006 Jeremy Katz <katzj@redhat.com> - 0.98.0-1.el5
- add support for creating nonsparse disk images (#217764)

* Mon Nov 20 2006 Jeremy Katz <katzj@redhat.com> - 0.97.0-1
- handle multiple nics with virt-install (#215726)

* Thu Nov 16 2006 Daniel P. Berrange <berrange@redhat.com> - 0.96.0-3
- Autodetect primary bridge device when creating guests (bz 207210, 201626)

* Tue Oct 24 2006 Jeremy Katz <katzj@redhat.com> - 0.96.0-2
- remove compat symlinks as apps have been changed

* Wed Oct 18 2006 Jeremy Katz <katzj@redhat.com> - 0.96.0-1
- improve check for if a machine is hvm capable to catch when support isn't
  allowed by the bios (#211276)
- cleanup after nfs mount failure on pv install (#206196)
- support for setting vcpus (#210516)

* Thu Oct 12 2006 Jeremy Katz <katzj@redhat.com> - 0.95.0-1
- support for blktap (danpb)
- name change

* Tue Oct  3 2006 Jeremy Katz <katzj@redhat.com> - 0.94.0-1
- Fix using block device as backing (#209138)
- Fix error handling for invalid install locations (danpb)
- Write out vcpu config (danpb)

* Wed Sep 20 2006 Jeremy Katz <katzj@redhat.com> - 0.93.0-1
- Fix hvm network xm config (danpb)
- Enable PAE with pae hvm hosts (danpb)
- Fix hvm block backed cds (danpb)
- Fix handling of block devs backed by vbds (danpb)
- Ensure we're on a xen kernel (#205889)
- Default to vncunused

* Wed Sep  6 2006 Jeremy Katz <katzj@redhat.com> - 0.92.0-2
- add patch to fix memory parsing in interactive mode
- fix deps

* Wed Aug 30 2006 Jeremy Katz <katzj@redhat.com> - 0.92.0-1
- Fix silly loop when asking about graphics support (misa)
- Fix passing macaddr
- Add support so that we reboot into the guest after installation finishes 

* Tue Aug 29 2006 Jeremy Katz <katzj@redhat.com> - 0.91.0-1
- add support for paravirt guests with framebuffer. 

* Mon Aug 21 2006 Jeremy Katz <katzj@redhat.com> - 0.90.1-1
- fix tab/space whitespace inconsistency

* Wed Aug 16 2006 Jeremy Katz <katzj@redhat.com> - 0.90.0-2
- set ExcludeArch so that it doesn't get pulled into all trees

* Wed Aug 16 2006 Jeremy Katz <katzj@redhat.com> - 0.90.0-1
- update to version with fixed HVM domain creation

* Wed Aug 16 2006 Jeremy Katz <katzj@redhat.com> - 0.9-2
- add some missing requires

* Tue Aug 15 2006 Jeremy Katz <katzj@redhat.com> - 0.9-1
- Initial build

